#!/usr/bin/bash
## CHECK INPUT VARS
[ -z "$1" ] && echo "No argument supplied : EXAMPLE: $./tst01.sh ./access.log-201604" && exit 1
##
## CHANGE : updated with 170.18 internal ip address : mfer : 05 July 2017
## Handle Name Authorities : mfer : 30 April 2016
## Handle Name Authorities: Alpha order - updated by ab 5-2-16 to remove erroneous NA
declare -a arr=("loc.admin/" "loc.afc/" "loc.amed/" "loc.asian/" "loc.award/" "loc.eur/" "loc.gdc/" "loc.gmd/" "loc.hisp/" "loc.law/" "loc.mbrsmi/" "loc.mbrsrs/" "loc.mss/" "loc.music/" "loc.natlib/" "loc.ndlp/" "loc.ndlpcoop/" "loc.nls/" "loc.pnp/" "loc.rbc/" "loc.standards/" "loc.test/" "loc.uscongress/" "loc.wdl/" "umich.dli.moa/")
##
## EMAILS : user MUST HAVE PERMISSIONS TO SEND EMAIL
#eemail=mfer@loc.gov,lseto@loc.gov,abau@loc.gov
##eemail=abau@loc.gov
eemail=mfer@loc.gov
cc=
## MORE THAN ONE EMAIL: mfer@loc.gov,abau@loc.gov
##
## Input File Name only
inputFileNameRaw=$1
inputFileName=${inputFileNameRaw##*/}
echo "INPUT FILE: ${inputFileName}"
##
## OUTPUT FILE NAME
outputFile=$inputFileName"_report.txt"
echo "OUTPUT FILE: ${outputFile}"
##
## DATE FORMATTED
genDate=$(date '+%Y%m%d-%H:%M:%S')
##
##Timestamp
echo "Gen Date: ${genDate}"
echo "Gen Date: ${genDate}" > $outputFile
echo "Search Access Log File: ${inputFileName}"
echo "Searching Access Log File: ${inputFileName}">>$outputFile
## get first line of file
echo "">>$outputFile
firstLine=$(head -n 1 $1)
echo "First Line: ${firstLine}"
echo "First Line:${firstLine}" >>$outputFile
echo "" >>$outputFile
## get last line of file
lastLine=$(tail -n 1 $1)
echo "Last Line: ${lastLine}"
echo "Last Line: ${lastLine}" >>$outputFile
echo "">>$outputFile
## get line count
lines=$(wc -l <$1)
echo "Lines: ${lines}"
echo "Lines: ${lines}" >>$outputFile
## get LC IP (140.147.*.*) count
lcIP=$(grep -c "^140.147" $1)
echo "LC IP (140.147.*.*) Hits: ${lcIP}"
echo "LC IP (140.147.*.*) Hits: ${lcIP}" >>$outputFile
## get LC IP count
lc02IP=$(grep -c "^170.18" $1)
tmpLCIP=$(expr $lcIP + $lc02IP)
echo "LC IP (172.18.*.*) Hits: ${lc02IP}"
echo "LC IP (172.18.*.*) Hits: ${lc02IP}" >>$outputFile
echo "TOTAL LC IP COUNT HITS: ${tmpLCIP}"
echo "TOTAL LC IP COUNT HITS: ${tmpLCIP}" >>$outputFile
## get NON-LC IP count
##nonIP=$(grep -v "^140.147" $1|wc -l)
nonIP=$(expr $lines - $tmpLCIP)
echo "Non-LC IP Hits: ${nonIP}" >>$outputFile
echo "Name Authority Grep Report"
echo "Name Authority Grep Report" >>$outputFile
## loop through array
for x in "${arr[@]}"
do
     ./hdl_report02.sh $x $1 $outputFile
done
echo "" >>$outputFile
echo "Report File Generated: $outputFile" >>$outputFile
echo "" >>$outputFile
echo "DONE" >>$outputFile
echo ""
echo "Sending Email: ${eemail}; ${cc}"
mail -s "Handle Access Log Report: ${outputFile}" $eemail < $outputFile
echo ""
echo "DONE"
